Subject: mutex lock and session cache problem

From: "Rok Zevnik" <[email-masked]>
Date: Wed, 26 Jun 2002 22:57:39 +0200

Hello,

I have a problem with mod_ssl running apache 2.0.36 on Linux Debian.
The ssl server hangs after couple of HTTPS requests and i have to restart
it.

In log file I get these two warnings when the connection hangs:

[warn]  Failed to acquire global mutex lock
[warn]  Failed to release global mutex lock

I found out that if I change the settings in ssl.conf from
SSLSessionCache         dbm:logs/ssl_scache
SSLSessionCacheTimeout  30

to
SSLSessionCache        none

then everything works OK.

Can anyone help me with this problem?

Thank you,
Rok

Log file when connection works OK

[info]  Connection to child 4 established (server, client)
[info]  Seeding PRNG with 136 bytes of entropy
[trace] OpenSSL: Handshake: start
[trace] OpenSSL: Loop: before/accept initialization
[trace] OpenSSL: Loop: SSLv3 read client hello A
[trace] OpenSSL: Loop: SSLv3 write server hello A
[trace] OpenSSL: Loop: SSLv3 write certificate A
[trace] OpenSSL: Loop: SSLv3 write server done A
[trace] OpenSSL: Loop: SSLv3 flush data
[trace] OpenSSL: Loop: SSLv3 read client key exchange A
[trace] OpenSSL: Loop: SSLv3 read finished A
[trace] OpenSSL: Loop: SSLv3 write change cipher spec A
[trace] OpenSSL: Loop: SSLv3 write finished A
[trace] OpenSSL: Loop: SSLv3 flush data
[trace] OpenSSL: Handshake: done
[info]  Connection: Client IP: 194.249.3.75, Protocol: SSLv3, Cipher:
RC4-MD5 (128/128 bits)
[info]  Initial (No.1) HTTPS request received for child 4 (server)
[info]  Connection to child 4 closed with unclean shutdown(server, client)

Log file when connection hangs:

[info]  Connection to child 4 established (server, client)
[info]  Seeding PRNG with 136 bytes of entropy
[trace] OpenSSL: Handshake: start
[trace] OpenSSL: Loop: before/accept initialization
*****[warn]  Failed to acquire global mutex lock
*****[warn]  Failed to release global mutex lock
[trace] Inter-Process Session Cache (DBM) Expiry: old: 1, new: 0, removed: 1
[trace] Inter-Process Session Cache: request=GET status=MISSED
id=CBDD0F6495EE486FCAED56F8E6B1E8A19E1C27CF1F74C008CFB79D8441CCC532 (session
renewal)
[trace] OpenSSL: Loop: SSLv3 read client hello A
[trace] OpenSSL: Loop: SSLv3 write server hello A
[trace] OpenSSL: Loop: SSLv3 write certificate A
[trace] OpenSSL: Loop: SSLv3 write server done A
[trace] OpenSSL: Loop: SSLv3 flush data
[trace] OpenSSL: Loop: SSLv3 read client key exchange A
[trace] OpenSSL: Loop: SSLv3 read finished A
[trace] OpenSSL: Loop: SSLv3 write change cipher spec A
[trace] OpenSSL: Loop: SSLv3 write finished A
[trace] OpenSSL: Loop: SSLv3 flush data

And here it stops and I have to restart it.

______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]